modimport("tile_adder.lua")

AddTile("WINDY", 75, "windy", {noise_texture = "levels/textures/noise_windy.tex"}, {noise_texture = "levels/textures/mini_noise_windy.tex"})

modimport("scripts/map/rooms/new_rooms")

local function LevelPreInit(level)

	if level.location ~= "forest" then
		return
	end

	table.insert(level.tasks, "WindyPlains")
end

AddLevelPreInitAny(LevelPreInit)

AddTask("WindyPlains", {
		locks = LOCKS.OUTERTIER,
		keys_given = {KEYS.TIER4, KEYS.TIER5, KEYS.TIER6},
		room_choices={ 
			["goddess_room1"] = 1,
			["goddess_room2"] = 4,
		}, 
		room_bg=GROUND.WINDY,
		background_room="goddess_room3",
		colour={r=0,g=1,b=1,a=1}
	})

	
		
		
AddRoomPreInit("BGGrass", function(room) room.contents.distributeprefabs.peach_tree1 = 0.012 end)
GLOBAL.terrain.filter.peach_tree1 = {GLOBAL.GROUND.ROAD, GLOBAL.GROUND.WOODFLOOR, GLOBAL.GROUND.CARPET, GLOBAL.GROUND.CHECKER, GLOBAL.GROUND.ROCKY, GLOBAL.GROUND.MARSH}

AddRoomPreInit("BGForest", function(room) room.contents.distributeprefabs.peach_tree2 = 0.012 end)
GLOBAL.terrain.filter.peach_tree2 = {GLOBAL.GROUND.ROAD, GLOBAL.GROUND.WOODFLOOR, GLOBAL.GROUND.CARPET, GLOBAL.GROUND.CHECKER, GLOBAL.GROUND.ROCKY, GLOBAL.GROUND.MARSH}

AddRoomPreInit("Clearing", function(room) room.contents.distributeprefabs.peach_tree3 = 0.012 end)
GLOBAL.terrain.filter.peach_tree3 = {GLOBAL.GROUND.ROAD, GLOBAL.GROUND.WOODFLOOR, GLOBAL.GROUND.CARPET, GLOBAL.GROUND.CHECKER, GLOBAL.GROUND.ROCKY, GLOBAL.GROUND.MARSH}


