local assets =
{
    Asset("ANIM", "anim/goddess_gate.zip"),
	Asset("IMAGE", "images/map_icons/goddess_gate.tex"),
	Asset("ATLAS", "images/map_icons/goddess_gate.xml")
}

local function connect (inst)
	local pos = inst:GetPosition()
    local ents = TheSim:FindEntities(pos.x, pos.y, pos.z, 20, nil, {"FX", "NOCLICK","DECOR","INLIMBO"}, {"player"})
	
    for i,v in pairs(ents) do
        if v.components.health then 
		
			local pos = inst:GetPosition()
			local ents = TheSim:FindEntities(pos.x, pos.y, pos.z, 9001, nil, {"FX", "NOCLICK","DECOR","INLIMBO"}, {"goddess_gate"})
			
			for i,v in pairs(ents) do
				
				if v:HasTag("goddess_gate1") then 
					inst.components.teleporter.targetTeleporter = v
				end
					
			end
		end
	end
end

local function light(inst)    
	inst.Light:Enable(true)   
end

local function extinguish(inst)
	inst.Light:Enable(false)
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()
	inst.entity:AddMiniMapEntity()
	inst.entity:AddLight()
	
	inst.MiniMapEntity:SetIcon( "goddess_gate.tex" )
	
	MakeObstaclePhysics(inst, .25)
	inst.Physics:SetCollisionGroup(COLLISION.CHARACTERS)
	inst.Physics:CollidesWith(COLLISION.CHARACTERS)
	
	local s = 4
	inst.Transform:SetScale(s,s,s)

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("goddess_gate")
    inst.AnimState:SetBuild("goddess_gate")
    inst.AnimState:PlayAnimation("idle")
	
	inst.Light:Enable(false)
    inst.Light:SetRadius(1)
    inst.Light:SetFalloff(0.2)
    inst.Light:SetIntensity(.75)
    inst.Light:SetColour(190 / 255, 250 / 255, 190 / 255)

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	inst:AddTag("goddess_gate")
	inst:AddTag("goddess_gate2")
	
	inst:AddComponent("teleporter")
    inst.components.teleporter.offset = 0
	
	inst:DoPeriodicTask(1, connect)
	
	inst:AddComponent("playerprox")
    inst.components.playerprox:SetDist(10, 10.1)
    inst.components.playerprox:SetOnPlayerNear(light)
    inst.components.playerprox:SetOnPlayerFar(extinguish)
	
    inst:AddComponent("inspectable")


    return inst
end

return Prefab("goddess_gate2", fn, assets)