local assets =
{
	Asset("ANIM", "anim/goddess_tea.zip"),
	Asset("ATLAS", "images/inventoryimages/goddess_tea.xml")
}

local prefabs = 
{
	"spoiled_food",
}

local function EatFn(inst, eater)
	if eater.components.health then
		local health = eater.components.health.maxhealth
		local rnd = math.random() * 100
		if rnd <= 20 then
			eater.components.health:SetMaxHealth(health + 10)
			eater.components.talker:Say("I feel a bit healthier now.")
		elseif rnd <= 40 then
			eater.components.health:SetMaxHealth(health + 20)
			eater.components.talker:Say("I feel healthier now.")
		elseif rnd <= 60 then
			eater.components.health:SetMaxHealth(health - 15)
			eater.components.talker:Say("I feel much less healthier now.")
		elseif rnd <= 80 then
			eater.components.health:SetMaxHealth(health - 5)
			eater.components.talker:Say("I feel less healthier now.")
		end 
	end
end


local function fn()
		local inst = CreateEntity()

		inst.entity:AddTransform()
		inst.entity:AddAnimState()
		inst.entity:AddNetwork()

		MakeInventoryPhysics(inst)

		inst.AnimState:SetBuild("goddess_tea")
		inst.AnimState:SetBank("goddess_tea")
		inst.AnimState:PlayAnimation("idle", false)

		inst:AddTag("preparedfood")
		inst:AddTag("goddess_tea")

		inst.entity:SetPristine()

		if not TheWorld.ismastersim then
			return inst
		end

		inst:AddComponent("edible")
		inst.components.edible.healthvalue = 100
		inst.components.edible.hungervalue = 100
		inst.components.edible.foodtype = FOODTYPE.VEGGIE
		inst.components.edible.sanityvalue = 100
		inst.components.edible:SetOnEatenFn(EatFn)

		
		inst:AddComponent("inspectable")
		inst.wet_prefix = "soggy"
		
		inst:AddComponent("inventoryitem")
		inst.components.inventoryitem.atlasname = "images/inventoryimages/goddess_tea.xml"

		inst:AddComponent("stackable")
		inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

		inst:AddComponent("perishable")
		inst.components.perishable:SetPerishTime(TUNING.PERISH_SLOW)
		inst.components.perishable:StartPerishing()
		inst.components.perishable.onperishreplacement = "spoiled_food"

		MakeSmallBurnable(inst)
		MakeSmallPropagator(inst)
		MakeHauntableLaunchAndPerish(inst)
		AddHauntableCustomReaction(inst, function(inst, haunter)
			--#HAUNTFIX
			--if math.random() <= TUNING.HAUNT_CHANCE_SUPERRARE then
				--if inst.components.burnable and not inst.components.burnable:IsBurning() then
					--inst.components.burnable:Ignite()
					--inst.components.hauntable.hauntvalue = TUNING.HAUNT_MEDIUM
					--inst.components.hauntable.cooldown_on_successful_haunt = false
					--return true
				--end
			--end
			return false
		end, true, false, true)
		---------------------        

		inst:AddComponent("bait")

		------------------------------------------------
		inst:AddComponent("tradable")
		
		------------------------------------------------  

		return inst
	end

return Prefab("goddess_tea", fn, assets, prefabs) 
